from __future__ import print_function
# V 10
'''
focale fixe
	f=720.0/35.0 * camera.data.lens
Zmin,Zmax calculés à partir de la bounding box
la taille de l'image en sortie est imposée par TailleDelaSortie=[720,576]
FINALEMENT ON NE DOIT DONNER QUE 
	TailleDelaSortie , frame_init,frame_finale,frame_pas , _NomDe_LObjet , _NomDe_LaCamera
'''

# V8 : distance a la camera
# V6 : pas de fichier
# CREE LES FICHIERS 
#vertices: str(V.co[0])+','+str(V.co[1])+','+str(V.co[2])+';'
# ET positions_camera : str(frame).zfill(5)+';'+str(loc[0])+','+str(loc[1])+','+str(loc[2])+';'+str(Inverse.item((i,j)))+','
# puis bpy.ops.script.python_file_run(filepath='CreeuneImage01.py')
import bpy,math,os,random

debug=False#debug=True4
_debug_temps=True






#########  #########  #########  les seuls variables  #########  #########  #########  #########  

TailleDelaSortie=[1280,1080]
TailleDelaSortie=[640,540]
TailleDelaSortie=[720,576]

frame_init,frame_finale,frame_pas=0,285,2
_NomDe_LObjet='maison a diviser'#_NomDe_LObjet='lens03ply' _NomDe_LObjet='aa'
_NomDe_LaCamera='Camera'


_Code=''#str(random.randint(0,10000))
path='images.'+_Code
if not os.path.exists(path):
	os.mkdir(path)
template=path+'/maison-'

#########  #########  #########  #########  #########  #########  #########  #########  #########  


print("taille de l'image de sortie ",TailleDelaSortie)
print('frames : ',frame_init,frame_init+frame_pas,frame_init+2*frame_pas,'...',frame_finale)
print('caméra :',_NomDe_LaCamera)
print('le répertoire de sortie est '+path)

scene=bpy.data.scenes['Scene']
obj=scene.objects[_NomDe_LObjet]
print('objet : '+_NomDe_LObjet+'. Nombre de vertices : '+str(len(obj.data.vertices)))
scene.objects.active=obj
obj.select=True
bpy.ops.object.transform_apply(location=True, rotation=True, scale=True)


camera=bpy.data.objects[_NomDe_LaCamera]
camera.rotation_mode='XYZ'
if camera.data.lens_unit != 'MILLIMETERS':
	print('!!!!!!!!!!!!!!!!!!!!!!!!!!!        la camera devrait etre en MILLIMETERS  !!!!!!!!!!!!!!!!!!!!!!!!!')
	camera.data.lens_unit = 'MILLIMETERS'
##################################LA LENTILLE :
#35 mm : fx,fy=720.0,720.0
f=720.0/35.0 * camera.data.lens #*1.75 #1.7(boules) //  // 1.8
fx,fy=f,f
print(str(camera.data.lens)+' mm' , 'f1=f2='+str(f))
#print('cx,cy,fx,fy : ',cx,cy,fx,fy)



#_ImageDeBase='statue100x100.png'#_ImageDeBase='statue512x512.png'#_ImageDeBase='statue1024x1024.png'
_ImageDeBase='balibalo'+_Code+'.png'
while _ImageDeBase in bpy.data.images:
	_ImageDeBase='Z'+_ImageDeBase
	

Zmin,Zmax=0.0,3.1#0Zmin,Zmax=0.0,2.5
Zmin = min( [obj.bound_box[i][2] for i in range(8) ])
Zmax = max( [obj.bound_box[i][2] for i in range(8) ])

bpy.ops.image.new(name=_ImageDeBase,width=TailleDelaSortie[0], height=TailleDelaSortie[1],color=(0, 0, 0, 1),alpha=True, generated_type='BLANK', float=False, gen_context='NONE')
image=bpy.data.images[_ImageDeBase]
image.filepath=_ImageDeBase
image.save()
Larg,Haut=image.size[0],image.size[1]#100,100#1024,1024
##################################LA LENTILLE :
cx=Larg/2.0
cy=Haut/2.0




"""

if os.path.isfile(_ImageDeBase):
	image=sf.Image.from_file(_ImageDeBase)
else:
	image = sf.Image.create(512, 512, sf.Color.BLACK)
print('rrrrrr',image.size)	
"""



























import numpy
from numpy  import matrix,pi,cos,sin
import time
t=time.time()
temps_initial=t
import re











if _debug_temps==True:
	#print('	temps estimee TOTAL V08:',0.08/52000*len(obj.data.vertices) + 0.1/251*(frame_finale-frame_init+1) + 0.27/6*(frame_finale-frame_init+1) + (frame_finale-frame_init+1)*17.5*(len(obj.data.vertices)/120000)*(Larg/1280.0)*(Haut/1080.0))
	print('	temps estimee TOTAL V10:',	(    0.08/52000*len(obj.data.vertices)+0.1/251+0.5E-3+(27.0/271455+0.075/19212)*len(obj.data.vertices))  *int((frame_finale-frame_init)/frame_pas))
	
	
	
	
	
	
	
	
	
	
	
	
	
	

#######0.8/52000 s/vert
print('##############################################################')
print('VERTICES')

if _debug_temps==True:
	print('	temps estimee:',0.08/52000*len(obj.data.vertices))
_PLY=[]#f=open('vertices','w')
#print(obj.name+':x,y,z,',file=f)
for V in obj.data.vertices:
	#ligne=str(V.co[0])+','+str(V.co[1])+','+str(V.co[2])+';'
	_PLY.append(V.co)#print(ligne,file=f)
#f.close()
if _debug_temps==True:
	print('   temps VERTICES',time.time()-t)

import shutil

def copyFile(src, dest):
	try:
		shutil.copy(src, dest)
	# eg. src and dest are the same file
	except shutil.Error as e:
		print('Error: %s' % e)
	# eg. source or destination doesn't exist
	except IOError as e:
		print('Error: %s' % e.strerror)
		
		
def Hprint(s):
	print(s)
















print('##############################################################')
print('CAMERA')
if _debug_temps==True:
	print('	temps estimee:',0.1/251*int((frame_finale-frame_init)/frame_pas))
t=time.time()
_CAMERA=[]
action=camera.animation_data.action # bpy.data.actions['Camera.001Action']
i,tmp,courbes=0,'',['' for i in range(6)]
while i<=5:
	#courbes[i]=action.groups['LocRot'].channels[i] # 
	courbes[i]=action.fcurves[i]
	i+=1


#f=open('positions_camera','w')
_Euler_tmp=camera.rotation_euler
for frame in range(frame_init,frame_finale+1,frame_pas):
	scene.frame_current=frame
	loc=[courbes[i].evaluate(frame) for i in range(3)]#camera.location
	#Hprint(loc) 
	#camera.rotation_euler=
	_Euler_tmp[0],_Euler_tmp[1],_Euler_tmp[2] = courbes[3].evaluate(frame),courbes[4].evaluate(frame),courbes[5].evaluate(frame)
	Inverse=matrix(_Euler_tmp.to_matrix()).getI()
	_CAMERA.append([frame,loc,Inverse])#print(str(frame).zfill(5)+';'+ligne,file=f) 
if _debug_temps==True:
	print('	 temps CAMERA',time.time()-t)	
# PLY contient [X,Y,Z] 
#	 




















# COPIE : CREE 'images/statue-'+str(frame).zfill(5)+'.png'	
print('##############################################################')
t=time.time()	
if _debug_temps==True:
	print('	temps estimee : ',0.5E-3*int((frame_finale-frame_init)/frame_pas))
print('COPY IMAGES')
for frame in range(frame_init,frame_finale+1,frame_pas):	
	fich=template+str(frame).zfill(5)+'.png'
	"""
	if not os.path.isfile(fich):
		copyFile(_ImageDeBase,fich )
	"""
	copyFile(_ImageDeBase,fich )
if _debug_temps==True:
	print('	temps COPY',time.time()-t)   
	

print('##############################################################')
print('creeuneimage10.py')
#bpy.ops.script.python_file_run(filepath='CreeuneImage01.py')


Vertices=[]#[matrix]


def LENS(X,Y,Z):
	xp=X/Z
	yp=Y/Z
	u = cx + xp*fx
	v = cy + yp*fy
	return u,v




"""
print('_CAMERA[0:6])',_CAMERA[0:6])
[[0, Vector((-0.6537628173828125, 2.768256187438965, 2.9293644428253174)), matrix([[ -8.43405910e-01,  -5.37276861e-01,  -8.21444227e-09],
		[  4.23704866e-01,  -6.65123019e-01,   6.14886638e-01],
		[ -3.30364358e-01,   5.18599047e-01,   7.88615492e-01]])],...
"""




























debug=False#True
PIXELS=[]
for i in _CAMERA[0:frame_finale-frame_init+1]:
	t=time.time()
	if _debug_temps==True:
		#print('  IMAGE :'+str(i[0])+': temps estimee de l image: ',17.5*(len(_PLY)/120000)*(Larg/1280.0)*(Haut/1080.0))
		print('  IMAGE :'+str(i[0])+': temps estimee max de l image: ',(27.0/271455+0.075/19212)*len(_PLY))
	points=[]
	points_tmp=[]
	image=''
	#t=time.time()
   
	frame=i[0]
	CAM=matrix([  [i[1][0]],[i[1][1]],[i[1][2]]  ])
	Inverse=i[2]
	####### creation d une image

	BB=Inverse*(-CAM)
	
	t0=time.time()
	if _debug_temps==True:
		print('    temps estimé du PLY : ',27.0/271455*len(_PLY))	
	for point in _PLY:
		#print(point)        	
		M=matrix([  [point[0]],[point[1]],[point[2]]  ])		 
		r=Inverse*M+BB#r=Inverse*(M-CAM)#la camera est en 0,0,0 dirigee vers le bas
		X,Y,Z=float(r[0]),float(r[1]),float(r[2])
		if Z < 0: 
			x,y=LENS(X,Y,-Z)
			x,y=int(x+0.5),int(y+0.5)
			#print('x,y,X,Y,-Z',x,y,X,Y,-Z)
			if x>=0 and y>=0 and x<Larg and y<Haut:
				c0 = int( (1.0*point[2]-Zmin)/(Zmax-Zmin) *100.0 )/100.0
				c0=min(1.0,max(c0,0.0))
				if debug==True:
					print(point[2],(1.0*point[2]-Zmin)/(Zmax-Zmin) *100.0,c0)
				c2 = 1.0-c0
				#print( (M-CAM),(M-CAM).getT() )
				#print( (M-CAM)*(M-CAM).getT() )
				distance=float( (M-CAM).getT() * (M-CAM))
				points.append([x,y,c0,c2,distance])
	if _debug_temps==True:
		print('           PLY : ',(time.time()-t0))
	
	t0=time.time()
	if _debug_temps==True:
		print('        temps estimé de limage : ',0.075/19212*len(points))				
	#print(distance)	
	#B=sorted( sorted( sorted(A, key=lambda tabl: tabl[2]) , key=lambda tabl: tabl[1] ) , key=lambda tabl: tabl[0] ) 
	points=sorted( sorted(points, key=lambda tabl: tabl[1]) , key=lambda tabl: tabl[0] )	
	#print(points)	
	print('	            on obtient '+str(len(	points))+' points dans le cadre sur '+str(len(_PLY))+' points du ply')	
	image=bpy.data.images[_ImageDeBase]
	image.filepath=template+str(frame).zfill(5)+'.png'
	print('	       '+image.filepath)
	
	
	pointCourant=[-1,-1]
	PIXELS=[0.0,0.0,0.0,1.0] * (Larg*Haut)
	DistTmp=1.0E9
	for point in points:#[x,y,c0,c2]
		#print(point)
		
		if [point[0],point[1]] != pointCourant:
			n=4*(point[0]+point[1]*Larg)
			PIXELS[n+0]=point[2] #image.pixels[n*4+0]=point[2]
			PIXELS[n+2]=point[3] #image.pixels[n*4+2]=point[3]
			pointCourant=[point[0],point[1]]
			DistTmp=1.0E9
		else:
			if distance < DistTmp:
				n=4*(point[0]+point[1]*Larg)
				PIXELS[n+0]=point[2] #image.pixels[n*4+0]=point[2]
				PIXELS[n+2]=point[3] #image.pixels[n*4+2]=point[3]
				#pointCourant=[point[0],point[1]]
				DistTmp = distance 
	if _debug_temps==True:
		print('              temps  de limage : ',(time.time()-t0))			
			
	"""
	for i in range(1000):		
		image.pixels[i]=1.0
	"""
	#print(len(image.pixels))
	#print(PIXELS[n:n+10])
	image.pixels=PIXELS
	image.save()
	if _debug_temps==True:
		print('   temps de l image: ',time.time()-t)
  
print('fini')  
#print(_PLY)	


'''
>>> courbe=action.groups['LocRot'].channels[0] # bpy.data.actions['Camera.001Action']...FCurve
action=camera.animation_data.action # bpy.data.actions['Camera.001Action']



'''
print('temps total :',time.time()-temps_initial)
